/* control-ap.c -
 *
 * Copyright 2007 OpenMoko, Inc.
 * Authored by Chia-I Wu <olv@openmoko.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <diversity-ap.h>
#include "diversity-control.h"

static gboolean control_ap_get_strength_grid(DiversityAp *ap, GArray **OUT_grid, GError **error);
#include "control-ap-glue.h"

static gboolean control_ap_get_strength_grid(DiversityAp *ap, GArray **OUT_grid, GError **error)
{
	GArray *array;
	const gint8 *grid;

	grid = diversity_ap_get_strength_grid(ap);

	array = g_array_sized_new(FALSE, FALSE, 1,
			DIVERSITY_AP_STRENGTH_GRID *
			DIVERSITY_AP_STRENGTH_GRID);

	g_array_append_vals(array, grid,
			DIVERSITY_AP_STRENGTH_GRID *
			DIVERSITY_AP_STRENGTH_GRID);

	*OUT_grid = array;

	return TRUE;
}
