/* diversity-jana.h - DiversityJana
 *
 * Copyright 2008 OpenMoko, Inc.
 * Authored by Chia-I Wu <olv@openmoko.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _DIVERSITY_JANA_H_
#define _DIVERSITY_JANA_H_

#define G_DISABLE_CAST_CHECKS

#include <glib-object.h>
#include <glib.h>

G_BEGIN_DECLS

#define DIVERSITY_TYPE_JANA		(diversity_jana_get_type())
#define DIVERSITY_JANA(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), DIVERSITY_TYPE_JANA, DiversityJana))
#define DIVERSITY_JANA_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), DIVERSITY_TYPE_JANA, DiversityJanaClass))
#define DIVERSITY_IS_JANA(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), DIVERSITY_TYPE_JANA))
#define DIVERSITY_IS_JANA_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), DIVERSITY_TYPE_JANA))
#define DIVERSITY_JANA_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), DIVERSITY_TYPE_JANA, DiversityJanaClass))

typedef struct _DiversityJana DiversityJana;
typedef struct _DiversityJanaClass DiversityJanaClass;

struct _DiversityJana {
	GObject parent_object;
};

struct _DiversityJanaClass {
	GObjectClass parent_class;

	void (*tag_added)(DiversityJana *jana, const gchar *uid, gdouble lon, gdouble lat, const gchar *desc);
};

GType diversity_jana_get_type(void) G_GNUC_CONST;

void diversity_jana_open_and_start(DiversityJana *jana);

G_END_DECLS

#endif /* _DIVERSITY_JANA_H_ */
