/* diversity-gypsy.h - DiversityGypsy
 *
 * Copyright 2008 OpenMoko, Inc.
 * Authored by Chia-I Wu <olv@openmoko.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _DIVERSITY_GYPSY_H_
#define _DIVERSITY_GYPSY_H_

#define G_DISABLE_CAST_CHECKS

#include <glib.h>
#include <diversity-equipment.h>
#include <diversity-object.h>

G_BEGIN_DECLS

#define DIVERSITY_TYPE_GYPSY		(diversity_gypsy_get_type())
#define DIVERSITY_GYPSY(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), DIVERSITY_TYPE_GYPSY, DiversityGypsy))
#define DIVERSITY_GYPSY_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), DIVERSITY_TYPE_GYPSY, DiversityGypsyClass))
#define DIVERSITY_IS_GYPSY(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), DIVERSITY_TYPE_GYPSY))
#define DIVERSITY_IS_GYPSY_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), DIVERSITY_TYPE_GYPSY))
#define DIVERSITY_GYPSY_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), DIVERSITY_TYPE_GYPSY, DiversityGypsyClass))

typedef struct _DiversityGypsy DiversityGypsy;
typedef struct _DiversityGypsyClass DiversityGypsyClass;

struct _DiversityGypsy {
	DiversityEquipment parent_object;
};

struct _DiversityGypsyClass {
	DiversityEquipmentClass parent_class;
};

GType diversity_gypsy_get_type(void) G_GNUC_CONST;

DiversityGypsy *diversity_gypsy_new(DiversityObject *obj);

G_END_DECLS

#endif /* _DIVERSITY_GYPSY_H_ */
