/* diversity-conf.h -
 *
 * Copyright 2008 OpenMoko, Inc.
 * Authored by Chia-I Wu <olv@openmoko.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef _DIVERSITY_CONF_H_
#define _DIVERSITY_CONF_H_

#include <glib.h>
#include <diversity-utils.h>

typedef struct _DiversityConf DiversityConf;

DiversityConf *diversity_conf_new(void);
void diversity_conf_free(DiversityConf *conf);

gboolean diversity_conf_save(DiversityConf *conf, const gchar *path);
gboolean diversity_conf_load(DiversityConf *conf, const gchar *path);

void diversity_conf_use_group(DiversityConf *conf, const gchar *group);
gchar **diversity_conf_list_groups(DiversityConf *conf, gsize *len);

void diversity_conf_set_integer(DiversityConf *conf, const gchar *key, gint v);
gboolean diversity_conf_get_integer(DiversityConf *conf, const gchar *key, gint *v);

void diversity_conf_set_boolean(DiversityConf *conf, const gchar *key, gboolean v);
gboolean diversity_conf_get_boolean(DiversityConf *conf, const gchar *key, gboolean *v);

void diversity_conf_set_rectangle(DiversityConf *conf, const gchar *key, const DiversityRectangle *rect);
gboolean diversity_conf_get_rectangle(DiversityConf *conf, const gchar *key, DiversityRectangle *rect);

void diversity_conf_set_dictionary(DiversityConf *conf, const gchar *key, GHashTable *dict);
gboolean diversity_conf_get_dictionary(DiversityConf *conf, const gchar *key, GHashTable *dict);

#endif /* _DIVERSITY_CONF_H_ */
