/* world-tree.h -
 *
 * Copyright 2007-2008 OpenMoko, Inc.
 * Authored by Chia-I Wu <olv@openmoko.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <diversity-object.h>
#include <diversity-viewport.h>

typedef struct _WorldTree WorldTree;
typedef void (*WorldTreePickFunc)(DiversityObject *picker, DiversityObject *obj, gpointer user_data);

WorldTree *world_tree_new(gint node_size, gint max_depth);
void world_tree_free(WorldTree *tree);

gboolean world_tree_add(WorldTree *tree, DiversityObject *obj);
gboolean world_tree_remove(WorldTree *tree, DiversityObject *obj);

gboolean world_tree_add_viewport(WorldTree *tree, DiversityViewport *view);
gboolean world_tree_remove_viewport(WorldTree *tree, DiversityViewport *view);

void world_tree_pick(WorldTree *tree, DiversityObject *picker, WorldTreePickFunc func, gpointer user_data);

#ifdef WORLD_TREE_DEBUG
void world_tree_dump(WorldTree *tree);
#endif
